[Top][All Lists]
[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]
[PATCH] tail -f: handle "-"/stdin once again
From: |
Jim Meyering |
Subject: |
[PATCH] tail -f: handle "-"/stdin once again |
Date: |
Mon, 07 Sep 2009 09:01:43 +0200 |
Here's the full patch:
>From b65cdea4dc1ec03be8bbc91cea261860373c8554 Mon Sep 17 00:00:00 2001
From: Jim Meyering <address@hidden>
Date: Mon, 7 Sep 2009 08:37:08 +0200
Subject: [PATCH] tail -f: handle "-"/stdin once again
* src/tail.c (main) [HAVE_INOTIFY]: When stdin (i.e., "-", or no args,
but not /dev/stdin) is specified on the command line, don't use inotify.
Reported by Bill Brelsford in <http://bugs.debian.org/545422>.
* tests/tail-2/follow-stdin: New file. Test for this.
* tests/Makefile.am (TESTS): Add the test.
* NEWS (Bug fixes): Mention it.
This bug was introduced in coreutils-7.5 via commit ae494d4b,
2009-06-02, "tail: use inotify if it is available".
---
NEWS | 9 +++++++++
THANKS | 1 +
src/tail.c | 14 +++++++++++++-
tests/Makefile.am | 1 +
tests/tail-2/follow-stdin | 41 +++++++++++++++++++++++++++++++++++++++++
5 files changed, 65 insertions(+), 1 deletions(-)
create mode 100755 tests/tail-2/follow-stdin
diff --git a/NEWS b/NEWS
index b02d2da..5c7fb82 100644
--- a/NEWS
+++ b/NEWS
@@ -31,6 +31,15 @@ GNU coreutils NEWS -*-
outline -*-
Before, this would print nothing and wait: stdbuf -o 4K tail -f /etc/passwd
Note that this bug affects tail -f only when its standard output is buffered,
which is relatively unusual.
+ [bug introduced in coreutils-7.5]
+
+ tail -f once again works with standard input. inotify-enabled tail -f
+ would fail when operating on a nameless stdin. I.e., tail -f < /etc/passwd
+ would say "tail: cannot watch `-': No such file or directory", yet the
+ relatively baroque tail -f /dev/stdin < /etc/passwd would work. Now, the
+ offending usage causes tail to revert to its conventional sleep-based
+ (i.e., not inotify-based) implementation.
+ [bug introduced in coreutils-7.5]
** New features
diff --git a/THANKS b/THANKS
index 0c5bb40..2410866 100644
--- a/THANKS
+++ b/THANKS
@@ -78,6 +78,7 @@ Bernhard Rosenkraenzer address@hidden
Bernhard Voelker address@hidden
Bert Deknuydt address@hidden
Bert Wesarg address@hidden
+Bill Brelsford address@hidden
Bill Peters address@hidden
Bjorn Helgaas address@hidden
Bob McCracken address@hidden
diff --git a/src/tail.c b/src/tail.c
index e3b9529..c53df9e 100644
--- a/src/tail.c
+++ b/src/tail.c
@@ -1982,7 +1982,19 @@ main (int argc, char **argv)
if (forever)
{
#if HAVE_INOTIFY
- if (!disable_inotify)
+ /* If the user specifies stdin via a command line argument of "-",
+ or implicitly by providing no arguments, we won't use inotify.
+ Technically, on systems with a working /dev/stdin, we *could*,
+ but would it be worth it? Verifying that it's a real device
+ and hooked up to stdin is not trivial, while reverting to
+ non-inotify-based tail_forever is easy and portable. */
+ bool stdin_cmdline_arg = false;
+
+ for (i = 0; i < n_files; i++)
+ if (STREQ (file[i], "-"))
+ stdin_cmdline_arg = true;
+
+ if (!disable_inotify && !stdin_cmdline_arg)
{
int wd = inotify_init ();
if (wd < 0)
diff --git a/tests/Makefile.am b/tests/Makefile.am
index d83d41b..6b3c2b1 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -428,6 +428,7 @@ TESTS = \
tail-2/assert-2 \
tail-2/big-4gb \
tail-2/flush-initial \
+ tail-2/follow-stdin \
tail-2/proc-ksyms \
tail-2/start-middle \
touch/dangling-symlink \
diff --git a/tests/tail-2/follow-stdin b/tests/tail-2/follow-stdin
new file mode 100755
index 0000000..46e7ce8
--- /dev/null
+++ b/tests/tail-2/follow-stdin
@@ -0,0 +1,41 @@
+#!/bin/sh
+# tail -f - would fail with the initial inotify implementation
+
+# Copyright (C) 2009 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ tail --version
+fi
+
+. $srcdir/test-lib.sh
+
+echo line > exp || framework_failure
+echo line > in || framework_failure
+
+fail=0
+timeout 1 tail -f < in > out 2> err
+
+# tail from coreutils-7.5 would fail
+test $? = 124 || fail=1
+
+# Ensure there was no error output.
+test -s err && fail=1
+
+# Ensure there was
+compare out exp || fail=1
+
+Exit $fail
--
1.6.4.2.419.gab238
[Prev in Thread] |
Current Thread |
[Next in Thread] |
- [PATCH] tail -f: handle "-"/stdin once again,
Jim Meyering <=